<?php

/**
  * Prestapress tab for admin panel, AdminPrestapress.php
  * @category admin
  *
  * @author AppSide
  * @copyright AppSide
  * @version 1.4
  *
  */
include_once(PS_ADMIN_DIR.'/../classes/AdminTab.php');

require_once(_PS_MODULE_DIR_."prestapress/prestapress.php");
require_once(_PS_MODULE_DIR_.'prestapress/classes/PspressCategory.php');
require_once(_PS_MODULE_DIR_.'prestapress/classes/PspressPublication.php');

class AdminPrestapress extends AdminTab
{
	private $preferences;
	
	public function __construct()
	{	
		global $cookie;
		
	 	$this->table = 'press_publication';
	 	$this->className = 'PspressPublication';
	 	$this->lang = true;
	 	$this->edit = true;
	 	$this->view = false;
	 	$this->delete = true;
		
		$this->module = 'prestapress';
		
		$this->preferences = Prestapress::getPreferences();
		
		$this->fieldsDisplay = array(
			'id_press_publication' => array('title' => $this->l('ID'), 'align' => 'center', 'width' => 30),
			'status' => array('title' => $this->l('Status'), 'align' => 'center', 'icon' => array('published' => 'enabled.gif', 'drafted' => 'warning.gif', 'suspended' => 'forbbiden.gif', 'default' => 'unknown.gif'), 'orderby' => false, 'search' => false),
			'title' => array('title' => $this->l('Title'), 'width' => 400),
			'date_on' => array('title' => $this->l('Publication date'), 'width' => 120,'type' => 'date','search' => false)
		);
		
		$this->fieldsDisplayPrestapressCategory = array(
			'id_press_category' => array('title' => $this->l('ID'), 'align' => 'center', 'width' => 30), 
			'name' => array('title' => $this->l('Name'), 'width' => 250),
		 	'position' => array('title' => $this->l('Position'), 'width' => 150),
			'active' => array('title' => $this->l('Displayed'), 'active' => 'status', 'align' => 'center', 'type' => 'bool', 'orderby' => false));
		
		if(isset($this->preferences['category_active']) && $this->preferences['category_active'] == 1){
			$this->_includeTabTitle = array($this->l('Categories'));
			$this->_includeTab = array('PrestapressCategory' => array('fieldsDisplay' => $this->fieldsDisplayPrestapressCategory));
		}
		
		parent::__construct();
	}
	
	public function displayForm($isMainTab = true)
	{
		global $currentIndex, $cookie;
			
		parent::displayForm();
		$languages = $this->_languages;
		$defaultLanguage = $this->_defaultFormLanguage; 
		$iso = Language::getIsoById((int)$this->_defaultFormLanguage);
		
		$currentDir = basename(dirname(__FILE__));
		$obj = $this->loadObject(true);
		
		$divLangName = 'title¤cexcerpt¤meta_description¤ccontent¤link_rewrite¤meta_keywords';
		
		echo '
			<script type="text/javascript" src="'._MODULE_DIR_.$currentDir.'/js/multiple-file-upload/jquery.MultiFile.js"></script>
			<script type="text/javascript" src="'._MODULE_DIR_.$currentDir.'/js/datepicker/jquery-ui-1.7.2.custom.min.js"></script>
			<link rel="stylesheet" type="text/css" href="'._MODULE_DIR_.$currentDir.'/js/datepicker/css/ui-lightness/jquery-ui-1.7.2.custom.css" />
			
			<script type="text/javascript">
			
				id_language = Number('.$defaultLanguage.');
				
				$(function(){ // wait for document to load 
					$("#prestapress_img").MultiFile({ 
						  STRING: {
						   	remove: \'&nbsp;&nbsp; <img src="../img/admin/disabled.gif" height="16" width="16" alt="x"/>\',
						   	denied: \''.$this->l('You cannot select a').' $ext '.$this->l('file, try again with another type..').'\' 
						  },
						  list: \'#prestapress-img-list\'	
					}); 
					
					$("#datepicker").datepicker({ dateFormat: \'yy-mm-dd\' });
				});	
				
			 </script>
			 
			<script type="text/javascript" src="'._MODULE_DIR_.$currentDir.'/js/prestapress.js"></script>
			
			<form action="'.$currentIndex.'&submitAdd'.$this->table.'AndStay=1&token='.$this->token.'" method="post" enctype="multipart/form-data">
			'.($obj->id ? '<input type="hidden" name="id_'.$this->table.'" value="'.$obj->id.'" />' : '').'
			<fieldset>
			<legend>'.$this->l('Content').'</legend>';
			
			// TITLE
			echo '	<label>'.$this->l('Title').' </label>
				<div class="margin-form">';
				foreach ($languages as $language)
				echo '	<div id="title_'.$language['id_lang'].'" style="display: '.($language['id_lang'] == $defaultLanguage ? 'block' : 'none').'; float: left;">
							<input size="40" id="input_title_'.$language['id_lang'].'" onkeyup="copyfriendlyURL();" type="text" name="title_'.$language['id_lang'].'" value="'.htmlentities($this->getFieldValue($obj, 'title', intval($language['id_lang'])), ENT_COMPAT, 'UTF-8').'" /><sup> *</sup>
						</div>';
				$this->displayFlags($languages, $defaultLanguage, $divLangName, 'title');
				echo '	</div><div class="clear space">&nbsp;</div>';
			
			// SUMMARY
			echo '<label>'.$this->l('Excerpt').'</label>
				<div class="margin-form">';
			foreach ($languages as $language)
				echo '<div id="cexcerpt_'.$language['id_lang'].'" style="display: '.($language['id_lang'] == $defaultLanguage ? 'block' : 'none').';float: left;">
						<textarea class="mceNoEditor" cols="80" rows="3" id="excerpt_'.$language['id_lang'].'" name="excerpt_'.$language['id_lang'].'">'.htmlentities(stripslashes($this->getFieldValue($obj, 'excerpt', $language['id_lang'])), ENT_COMPAT, 'UTF-8').'</textarea>
					</div>';
				$this->displayFlags($languages, $defaultLanguage, $divLangName, 'cexcerpt');
			echo '</div>
				<div class="clear space">&nbsp;</div>';
		
		// CONTENT WYSIWYG
		echo '	<label>'.$this->l('Content').' </label>
				<div class="margin-form">';
		foreach ($languages as $language)
			echo '	<div id="ccontent_'.$language['id_lang'].'" style="display: '.($language['id_lang'] == $defaultLanguage ? 'block' : 'none').';float: left;">
						<textarea class="rte"  id="content_'.$language['id_lang'].'" name="content_'.$language['id_lang'].'">'.htmlentities(stripslashes($this->getFieldValue($obj, 'content', $language['id_lang'])), ENT_COMPAT, 'UTF-8').'</textarea>
					</div>';
		$this->displayFlags($languages, $defaultLanguage, $divLangName, 'ccontent');
	
		echo '</div>
				</fieldset>';
		echo '	<div class="clear space">&nbsp;</div>';
		
		// MEDIAS
		echo '<fieldset>
				<legend>'.$this->l('Medias').'</legend>
				<label>'.$this->l('Images').' </label>
				<div class="margin-form">
					<input  type="file" accept="gif|jpg|png" maxlength="'.$this->preferences['nb_max_img'].'" id="prestapress_img" name="prestapress_img[]" /> .jpg, .png, .gif
				</div>
				<div class="margin-form" id="prestapress-img-list"></div>
				<div class="margin-form">';
					$relative = $this->preferences['img_save_path'].$obj->id."/";
					$images = (Tools::getValue('id_press_publication') ? $obj->getAllImages() : array());
					foreach($images as $val){
						$filename = $val['id_press_image'].'.'.$val['type'];
						if(file_exists(_PS_ROOT_DIR_."/".$relative.$filename)){
							echo '<div style="float:left;margin-left:10px;">
									<input type="radio" id="prestapress_img_default_'.$val['id_press_image'].'" name="prestapress_img_default" '.(intval($val['default']) == 1 ? 'checked' : '').' value="'.$val['id_press_image'].'">
									<a href="'.$currentIndex.'&deleteImg&token='.$this->token.'&id_press_publication='.$obj->id.'&id_img='.$val['id_press_image'].'" title="'.$this->l('Delete').'" onclick="if(!confirm(\''.$this->l('Are you sure you want to delete this picture').'\')) return false;"><img src="../img/admin/delete.gif" alt="'.$this->l('Delete').'" align="right" /></a><br />
									<label style="float:none; margin:0; padding:0; width:auto;" for="prestapress_img_default_'.$val['id_press_image'].'"><img src="'.__PS_BASE_URI__.$this->preferences['img_save_path']."timthumb.php?src=".__PS_BASE_URI__.$relative.$filename.'&h=100&w=100" /></label>
								  </div>';
						}
					}
	
				echo '</div>';
				
		echo '</fieldset>';
		echo '	<div class="clear space">&nbsp;</div>';
		
		if(isset($this->preferences['category_active']) && $this->preferences['category_active'] == 1){
			// CATEGORIES
			echo '<fieldset><legend>'.$this->l('Categories').'</legend>';
			echo '<label>'.$this->l('Publication categories').'</label>
					<div class="margin-form"> ';
					
					$prestapress_categories = Tools::getValue('groupBox', $obj->getCategories());
					$categories = PspressCategory::listCategories($defaultLanguage,false);
					
					if (sizeof($categories)){
					  echo '<table cellspacing="0" cellpadding="0" class="table" style="width: 29.5em;">
							<tr>
								<th><input type="checkbox" name="checkme" class="noborder" onclick="checkDelBoxes(this.form, \'groupBox[]\', this.checked)" /></th>
								<th>'.$this->l('ID').'</th>
								<th>'.$this->l('Category name').'</th>
							</tr>';
						$irow = 0;
						foreach ($categories as $cat)
						{
							echo '
							<tr class="'.($irow++ % 2 ? 'alt_row' : '').'">
								<td><input type="checkbox" name="groupBox[]" class="groupBox" id="groupBox_'.$cat['id_press_category'].'" value="'.$cat['id_press_category'].'" '.(in_array($cat['id_press_category'],$prestapress_categories) ? 'checked="checked" ' : '').'/></td>
								<td>'.$cat['id_press_category'].'</td>
								<td><label for="groupBox_'.$cat['id_press_category'].'" class="t">'.$cat['name'].'</label></td>
							</tr>';
						}
						echo '</table>';
					} else
						echo '<p>'.$this->l('No category created').'</p>';
			  echo '</div>
					<div class="clear">&nbsp;</div>';
			echo '</fieldset><div class="clear space">&nbsp;</div>';
		}
		
		if(isset($this->preferences['product_active']) && $this->preferences['product_active'] == 1){
		// PRODUCTS
		echo '<fieldset>
				<legend>'.$this->l('Products').'</legend>';
		
		$accessories = (Tools::getValue('id_press_publication') ? $obj->getProductsLite(intval($cookie->id_lang)) : array());
		
		echo '<div id="divAccessories">';
				foreach ($accessories as $accessory)
					echo $accessory['name'].(!empty($accessory['reference']) ? ' ('.$accessory['reference'].')' : '').' <span onclick="delAccessoryProduct('.$accessory['id_product'].');" style="cursor: pointer;"><img src="../img/admin/delete.gif" class="middle" alt="" /></span><br />';
		echo '</div>';
		
		echo '<div class="margin-form"> 

			<input type="hidden" name="inputAccessories" id="inputAccessories" value=" ';	
			foreach ($accessories as $accessory) echo $accessory['id_product'].'-';
			echo '" />
				
			<input type="hidden" name="nameAccessories" id="nameAccessories" value=" ';
			foreach ($accessories as $accessory) echo $accessory['name'].'¤';
			echo '" />';
			
			echo '<script type="text/javascript">
					var formProduct;
					var accessories = new Array();
				</script>
			
			<link rel="stylesheet" type="text/css" href="'._MODULE_DIR_.$currentDir.'/js/autocomplete/jquery.autocomplete.css" />
			<script type="text/javascript" src="'._MODULE_DIR_.$currentDir.'/js/autocomplete/jquery.autocomplete.js"></script>';
	
			echo '<div id="ajax_choose_product" style="padding:6px; padding-top:2px; width:600px;">
							<p class="clear">'.$this->l('Begin typing the first letters of the product name, then select the product from the drop-down list:').'</p>
							<input type="text" value="" id="product_autocomplete_input" />
							<img onclick="$(this).prev().search();" style="cursor: pointer;" src="../img/admin/add.gif" alt="'.$this->l('Add an accessory').'" title="'.$this->l('Add an accessory').'" />
						</div>
						<script type="text/javascript">
							urlToCall = null;
							/* function autocomplete */
							$(function() {
								$(\'#product_autocomplete_input\')
									.autocomplete(\'ajax_products_list.php\', {
										minChars: 1,
										autoFill: true,
										max:20,
										matchContains: true,
										mustMatch:true,
										scroll:false,
										cacheLength:0,
										formatItem: function(item){ return item[1]+\' - \'+item[0]; }
									}).result(addAccessoryProduct);
								$(\'#product_autocomplete_input\').setOptions({
									extraParams: {excludeIds : $(\'#inputAccessories\').val().replace(/\-/g,\',\').replace(/\,$/,\'\')}
								});
							});
						</script>';
			echo '	</div>';
			echo '</fieldset><div class="clear space">&nbsp;</div>';
		}
		
		if(isset($this->preferences['related_active']) && $this->preferences['related_active'] == 1){
			
			// RELATED ARTICLES
			echo '<fieldset>
					<legend>'.$this->l('Related articles').'</legend>';
				
				$prestapress_related = Tools::getValue('groupRelated', $obj->getRelated());
				$articles = PspressPublication::listPrestapress(intval($cookie->id_lang),false,0,null,null,null,$obj->id);
				
				echo '<label>'.$this->l('Select related articles').' </label>
						<div class="margin-form" style="height:140px; overflow-x:hidden; overflow-y:scroll; padding:0;">';
					
				if(count($articles)){
					
					echo '<table cellspacing="0" cellpadding="0" class="table" style="width: 29.5em;">
								<tr>
									<th></th>
									<th>'.$this->l('ID').'</th>
									<th>'.$this->l('Title').'</th>
								</tr>';
						
						$irow = 0;
						foreach ($articles as $post){
							
							if($post['id_press_publication'] == $obj->id) continue;
	
							echo '<tr class="'.($irow++ % 2 ? 'alt_row' : '').'">
									<td><input type="checkbox" name="groupRelated[]" class="groupBox" id="groupRelated_'.$post['id_press_publication'].'" value="'.$post['id_press_publication'].'" '.(in_array($post['id_press_publication'],$prestapress_related) ? 'checked="checked" ' : '').'/></td>
									<td>'.$post['id_press_publication'].'</td>
									<td><label for="groupRelated_'.$post['id_press_publication'].'" class="t">'.$post['title'].'</label></td>
								</tr>';
						}
						
					echo '</table>';
					
					}else{
						echo '<p>'.$this->l('No posts created').'</p>';
					}
					
				echo  '</div><div class="clear">&nbsp;</div>';
				
			echo '</fieldset><div class="clear space">&nbsp;</div>';
		}
			
		// SEO
		echo '<fieldset>
				<legend>'.$this->l('SEO').'</legend>';

			// URL REWRITE
			echo '	<label>'.$this->l('Friendly URL').' </label>
					<div class="margin-form">';
				foreach ($languages as $language)
					echo '<div id="link_rewrite_'.$language['id_lang'].'" style="display: '.($language['id_lang'] == $defaultLanguage ? 'block' : 'none').'; float: left;">
							<input size="40" type="text" id="input_link_rewrite_'.$language['id_lang'].'" name="link_rewrite_'.$language['id_lang'].'" value="'.htmlentities($this->getFieldValue($obj, 'link_rewrite', intval($language['id_lang'])), ENT_COMPAT, 'UTF-8').'" />
						</div>';
				$this->displayFlags($languages, $defaultLanguage, $divLangName, 'link_rewrite');
				echo '	</div><div class="clear space">&nbsp;</div>';
				
			// DESC
			echo '	<label>'.$this->l('META description').'</label>
					<div class="margin-form">';
				foreach ($languages as $language)
					echo '<div id="meta_description_'.$language['id_lang'].'" style="display: '.($language['id_lang'] == $defaultLanguage ? 'block' : 'none').';float: left;">
							<textarea class="mceNoEditor" cols="80" rows="3" name="meta_description_'.$language['id_lang'].'">'.htmlentities(stripslashes($this->getFieldValue($obj, 'meta_description', $language['id_lang'])), ENT_COMPAT, 'UTF-8').'</textarea>
						</div>';
				$this->displayFlags($languages, $defaultLanguage, $divLangName, 'meta_description');
			echo '</div>
					<div class="clear space">&nbsp;</div>';
				
			// KEYWORDS
			echo '<label>'.$this->l('META keywords').' </label>
					<div class="margin-form">';
				
			foreach ($languages as $language)
					echo '<div id="meta_keywords_'.$language['id_lang'].'" style="display: '.($language['id_lang'] == $defaultLanguage ? 'block' : 'none').'; float: left;">
							<input size="40" type="text" name="meta_keywords_'.$language['id_lang'].'" value="'.htmlentities($this->getFieldValue($obj,'meta_keywords', intval($language['id_lang'])), ENT_COMPAT, 'UTF-8').'" />
						</div>';
				$this->displayFlags($languages, $defaultLanguage, $divLangName,'meta_keywords');
				
				echo '</div><div class="clear space">&nbsp;</div>';
			
				
		echo '</fieldset><div class="clear space">&nbsp;</div>';
		
		
		// OPTIONS
		echo '<fieldset><legend>'.$this->l('Publication options').'</legend>';
		
		echo '	<label>'.$this->l('Status').' </label>
				<div class="margin-form">  
					<select name="status">
						<option value="published" '.($this->getFieldValue($obj, 'status') == 'published' ? 'selected' : '').'>'.$this->l('Published').'</option>
						<option value="drafted" '.($this->getFieldValue($obj, 'status') == 'drafted' ? 'selected' : '').'>'.$this->l('Drafted').'</option>
						<option value="suspended" '.($this->getFieldValue($obj, 'status') == 'suspended' ? 'selected' : '').' >'.$this->l('Suspended').'</option>
					</select>
				</div>
				<div class="clear">&nbsp;</div>';
		
		$date_on = $this->getFieldValue($obj,'date_on') == "" ? date('Y-m-d') : $this->getFieldValue($obj,'date_on');
		
		echo '	<label> '.$this->l('Publication date').' </label>
				<div class="margin-form">
					<input type="text" name="date_on" value="'.$date_on.'" id="datepicker" />
				</div>
				<div class="clear">&nbsp;</div>';
	
		echo '</fieldset><div class="clear"></div>';
		
		// SUBMIT
		echo '	<div class="margin-form space">
					<input type="submit" value="'.$this->l('   Save   ').'" name="submitAdd'.$this->table.'" class="button" />
				</div>
				<div class="small"><sup>*</sup> '.$this->l('Required field').'</div>
			
		</form>';
		
		require_once(_PS_MODULE_DIR_.$currentDir.'/tinymce.php');
	}

	public function postProcess()
	{
		global $currentIndex, $cookie;
		if (!isset($this->table)) return false;
		$token = Tools::getValue('token') ? Tools::getValue('token') : $this->token;

		if (Tools::getValue('submitAdd'.$this->table))
		{
			$this->validateRules();
			if (!sizeof($this->_errors))
			{
				$id = intval(Tools::getValue($this->identifier));
				if (isset($id) AND !empty($id)){ /* Object update */				
					if ($this->tabAccess['edit'] === '1'){
						$object = new $this->className($id);
						if (Validate::isLoadedObject($object)){
							$this->copyFromPost($object, $this->table);
							$result = $object->update();
							if (!$result) $this->_errors[] = Tools::displayError('an error occurred while updating object').' <b>'.$this->table.'</b> ('.Db::getInstance()->getMsgError().')';
							}else $this->_errors[] = Tools::displayError('an error occurred while updating object').' <b>'.$this->table.'</b> '.Tools::displayError('(cannot load object)');
					}else $this->_errors[] = Tools::displayError('You do not have permission to edit anything here.');
				}else{ /* Object creation */
					if ($this->tabAccess['add'] === '1'){
						$object = new $this->className();
						$this->copyFromPost($object, $this->table);
						if (!$object->add()) $this->_errors[] = Tools::displayError('an error occurred while creating object').' <b>'.$this->table.' ('.mysql_error().')</b>';
						$id = $object->id;
					}
					else $this->_errors[] = Tools::displayError('You do not have permission to add anything here.');
				}
			}
			
			// Updating prestapress groups
			if (!sizeof($this->_errors))
			{
				$groupList = Tools::getValue('groupBox');
				$object->cleanCategories();
				if (is_array($groupList) AND sizeof($groupList) > 0)
					$object->addCategories($groupList);
				
				$object->cleanProducts();
				if(Tools::getValue('inputAccessories')){
					$productArray = explode('-',Tools::getValue('inputAccessories'),-1);	
					$object->addProducts($productArray);
				}
				
				
				$groupRelated = Tools::getValue('groupRelated');
				$object->cleanRelated();
				if (is_array($groupRelated) AND sizeof($groupRelated) > 0)
					$object->addRelated($groupRelated);
				
				if(isset($_FILES['prestapress_img']) && !empty($_FILES['prestapress_img']['tmp_name'][0])){
					
					$save_path = _PS_ROOT_DIR_."/".rtrim($this->preferences['img_save_path'],'/')."/".$id;
					if(!is_dir($save_path)) mkdir($save_path);
					
					foreach($_FILES['prestapress_img']['name'] as $key => $val){
						if(empty($val)) continue;
						try{
							$idImg = 0;
							$file['name'] = $val;
							$file['type'] = $_FILES['prestapress_img']['type'][$key];
							$file['error'] = $_FILES['prestapress_img']['error'][$key];
							$file['size'] = $_FILES['prestapress_img']['size'][$key];
							$file['tmp_name'] = $_FILES['prestapress_img']['tmp_name'][$key];
							
							$ext = substr(strrchr($file['name'],'.'), 1);
							$this->checkFile($file,$save_path);
							$idImg = $object->addImage($ext,0);
							$this->uploadFile($file,$save_path.'/'.$idImg.'.'.$ext);
							
						}catch(Exception $e){
							$this->_errors[] = Tools::displayError($e->getMessage());
							if($idImg) $object->delImage($idImg);
						}
					}	
				}
	
				if(Tools::getValue('prestapress_img_default')){
					$idImg = Tools::getValue('prestapress_img_default');
					$object->setImageDefault($idImg);
				}elseif($object->getAllImages(true) > 0){
					$object->setImageDefault(0);
				}
				
			}
			
			if (!sizeof($this->_errors)){
				$parent_id = intval(Tools::getValue('id_parent', 1));
				if ($back = Tools::getValue('back')) Tools::redirectAdmin(urldecode($back).'&conf=4');
				
				if (Tools::isSubmit('submitAdd'.$this->table.'AndStay') && Tools::getValue($this->identifier)) Tools::redirectAdmin($currentIndex.'&'.$this->identifier.'='.$object->id.'&conf=4&update'.$this->table.'&token='.$token);
				if (Tools::isSubmit('submitAdd'.$this->table.'AndStay')) Tools::redirectAdmin($currentIndex.'&'.$this->identifier.'='.$object->id.'&conf=3&update'.$this->table.'&token='.$token);
				if (Tools::isSubmit('submitAdd'.$this->table.'AndBackToParent')) Tools::redirectAdmin($currentIndex.'&'.$this->identifier.'='.$parent_id.'&conf=3&token='.$token);
				Tools::redirectAdmin($currentIndex.($parent_id ? '&'.$this->identifier.'='.$object->id : '').'&conf=3&token='.$token);
			}
			
			$this->_errors = array_unique($this->_errors);
		
		}elseif (isset($_GET['delete'.$this->table]) || Tools::getValue('submitDel'.$this->table)){
			//delete publications
			if ($this->tabAccess['delete'] === '1'){
	
				$prestapress_items = array();
				if(Tools::getValue('submitDel'.$this->table)){
					$prestapress_items = $_POST[$this->table.'Box'];
				}elseif(isset($_GET['delete'.$this->table])){
					$prestapress_items[0] = Tools::getValue($this->identifier);
				}
				
				foreach($prestapress_items as $val){
					$id_prestapress = intval($val);
					$object = new $this->className($id_prestapress);		
					//delete all images		
					$prestapress_images = $object->getAllImages(); 
					$relative = $this->preferences['img_save_path'].$object->id."/";	
					foreach($prestapress_images as $img){
						$filename = $img['id_press_image'].'.'.$img['type'];
						if(file_exists(_PS_ROOT_DIR_."/".$relative.$filename)){
							@unlink(_PS_ROOT_DIR_."/".$relative.$filename);
						}
					}
					
					$object->cleanImages();
					$object->cleanProducts();
					$object->cleanCategories();
					if(is_dir(_PS_ROOT_DIR_."/".$relative)){ @rmdir(_PS_ROOT_DIR_."/".$relative); }
				}
			}
			parent::postProcess();			
			
		}elseif (Tools::isSubmit('deleteImg')){
				//delete one image
				$id_prestapress = intval(Tools::getValue($this->identifier));
				$id_prestapress_image = Tools::getValue('id_img');
				$object = new $this->className($id_prestapress);
				$prestapress_image = $object->getImage($id_prestapress_image); 
				$relative = $this->preferences['img_save_path'].$object->id."/";	
				
				$filename = $prestapress_image['id_press_image'].'.'.$prestapress_image['type'];					
				if(file_exists(_PS_ROOT_DIR_."/".$relative.$filename)){
					@unlink(_PS_ROOT_DIR_."/".$relative.$filename);
					$object->delImage($id_prestapress_image);
					
					if($prestapress_image['default'] == 1){
						//set new default image
						$object->setImageDefault(0);
					}
					
				}
				 if($object->getAllImages(true) == 1) $object->setImageDefault(0);
				 Tools::redirectAdmin($currentIndex.'&'.$this->identifier.'='.$object->id.'&conf=4&update'.$this->table.'&token='.$token);
			
			}else{
				parent::postProcess();
			}
	}
	
	protected function checkFile($_file,$save_path){
		
		$supported_formats = explode("|",$this->preferences['file_formats']);
		$save_path = rtrim($save_path,'/')."/";
		$MAX_FILENAME_LENGTH = 128;
		$max_file_size_in_bytes = 2147483647;
		
		$uploadErrors = array(0 => "There is no error, the file uploaded with success",
							  1 => "The uploaded file exceeds the upload_max_filesize directive in php.ini",
							  2 => "The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form",
							  3 => "The uploaded file was only partially uploaded",
							  4 => "No file was uploaded",
							  6 => "Missing a temporary folder");
		
		$tmp_file = $_file['tmp_name'];
		$file_name = $_file["name"];
		//erreurs diverses
		if (isset($_file["error"]) && $_file["error"] != 0) {
			throw new Exception("Error in file ".$file_name." with message : ".$uploadErrors[$_file["error"]]);
		}
		$ext = substr(strrchr($file_name,'.'), 1);
		if(count($supported_formats) > 0){
			if(!in_array($ext,$supported_formats)) 
				throw new Exception("File format \".".$ext."\" is not allowed  (".implode(',',$supported_formats).")");
		}
		$file_size = @filesize($tmp_file);
		//size
		if($file_size > $max_file_size_in_bytes){
			throw new Exception("the file ".$file_name." is too heavy (".$file_size."), max size : ".$max_file_size_in_bytes);
		}
		//check filename
		if (strlen($file_name) == 0 || strlen($file_name) > $MAX_FILENAME_LENGTH) {
			throw new Exception("the filename is not valid.");
		}	
		return true;	
	}
	
	protected function uploadFile($_file,$file_name){
		$tmp_file = $_file['tmp_name'];
		if (!@move_uploaded_file($tmp_file,$file_name)) {
			throw new Exception("the file ".$file_name." was not uploaded");
		}	
		return true;
	}
	
	
	protected function l($string, $class = __CLASS__, $addslashes = FALSE, $htmlentities = TRUE)
	{					
		global $_MODULES, $_MODULE, $_LANGADM, $cookie;
		
		$id_lang = (!isset($cookie) OR !is_object($cookie)) ? intval(Configuration::get('PS_LANG_DEFAULT')) : intval($cookie->id_lang);
		$file = _PS_MODULE_DIR_.'prestapress/'.Language::getIsoById($id_lang).'.php';
		if (file_exists($file) AND include_once($file))
			$_MODULES = !empty($_MODULES) ? array_merge($_MODULES, $_MODULE) : $_MODULE;
		if (!is_array($_MODULES))
			return (str_replace('"', '&quot;', $string));
		$source = Tools::strtolower(get_class($this));
		$string2 = str_replace('\'', '\\\'', $string);
		
		$currentKey = '<{prestapress}'._THEME_NAME_.'>adminprestapress_'.md5($string2);
		$defaultKey = '<{prestapress}prestashop>adminprestapress_'.md5($string2);
		
		$_MODULES = array_change_key_case($_MODULES,CASE_LOWER);
		
		if (key_exists($currentKey, $_MODULES)){
			$str = $_MODULES[$currentKey];	
		}elseif (key_exists($defaultKey, $_MODULES))
			$str = $_MODULES[$defaultKey];
		elseif (key_exists('AdminTab'.md5($string2), $_LANGADM))
			$str = $_LANGADM['AdminTab'.md5($string2)];
		else{
			return parent::l($string);
		}
		
		$str = $htmlentities ? htmlentities($str, ENT_QUOTES, 'utf-8') : $str;
		return str_replace('"', '&quot;', ($addslashes ? addslashes($str) : stripslashes($str)));
	}
	
	public function getList($id_lang, $orderBy = NULL, $orderWay = NULL, $start = 0, $limit = NULL)
	{	
		$orderBy = Tools::getValue($this->table.'Orderby', "id_press_publication");
		$orderWay = Tools::getValue($this->table.'Orderway', 'DESC');
		echo "<h2>".$this->l('Articles')."</h2>";
		parent::getList($id_lang,$orderBy,$orderWay,$start,$limit);
	}
	
}

?>
