<?php

include_once(PS_ADMIN_DIR.'/../classes/AdminTab.php');

class AdminPrestapressCategory extends AdminTab{

	public function __construct()
	{
	 	$this->table = 'press_category';
	 	$this->className = 'PspressCategory';
	 	$this->lang = true;
	 	$this->edit = true;
	 	$this->delete = true;
		
		$this->fieldsDisplay = array('id_press_category' => array('title' => $this->l('ID'), 'align' => 'center', 'width' => 25),
									 'name' => array('title' => $this->l('Category name'), 'width' => 150),
									 'position' => array('title' => $this->l('Position'), 'width' => 150),
									 'active' => array('title' => $this->l('Displayed'), 'active' => 'status', 'align' => 'center', 'type' => 'bool', 'orderby' => false));
		
		$this->identifier = 'id_press_category';
		
		parent::__construct();
	}
	
	public function displayForm($isMainTab = true)
	{
		global $currentIndex, $cookie;
		
		$currentDir = basename(dirname(__FILE__));
		
		parent::displayForm();
		$languages = $this->_languages;
		$defaultLanguage = $this->_defaultFormLanguage; 
		$iso = Language::getIsoById((int)$this->_defaultFormLanguage);
		$obj = $this->loadObject(true);
		
		$nbCategories = $obj->nbCategories();
		if(!$obj->id){ 
			$nbCategories++;
			 $obj->position = $nbCategories;
		}
		
		$divLangName = 'cname¤ccontent¤clink_rewrite¤meta_keywords¤meta_description';
		
		echo '<script type="text/javascript">
				id_language = Number('.$defaultLanguage.');
			</script>
		
		<script type="text/javascript" src="'._MODULE_DIR_.'prestapress/js/prestapress.js"></script>
		
		<form action="'.$currentIndex.'&submitAdd'.$this->table.'AndStay=1&token='.$this->token.'" method="post">
			'.($obj->id ? '<input type="hidden" name="id_'.$this->table.'" value="'.$obj->id.'" />' : '').'
			<fieldset>
				
				<legend>'.$this->l('Categories').'</legend>
				
				<label>'.$this->l('Name').' </label>
				<div class="margin-form">';
				foreach ($languages as $language)
					echo '<div id="cname_'.$language['id_lang'].'" style="display: '.($language['id_lang'] == $defaultLanguage ? 'block' : 'none').'; float: left;">
								<input size="33" type="text" id="input_title_'.$language['id_lang'].'" name="name_'.$language['id_lang'].'" onkeyup="copyfriendlyURL();" value="'.htmlentities($this->getFieldValue($obj, 'name', intval($language['id_lang'])), ENT_COMPAT, 'UTF-8').'" /><sup> *</sup>
						 </div>';
					$this->displayFlags($languages, $defaultLanguage, $divLangName, 'cname');
					echo '</div>
					<div class="clear space">&nbsp;</div>';
				
				// CONTENT WYSIWYG
				echo '<label>'.$this->l('Description').' </label>
						<div class="margin-form">';
							foreach ($languages as $language)
								echo '	<div id="ccontent_'.$language['id_lang'].'" style="display: '.($language['id_lang'] == $defaultLanguage ? 'block' : 'none').';float: left;">
									<textarea class="rte"  id="content_'.$language['id_lang'].'" name="content_'.$language['id_lang'].'">'.htmlentities(stripslashes($this->getFieldValue($obj, 'content', $language['id_lang'])), ENT_COMPAT, 'UTF-8').'</textarea>
								</div>';
					$this->displayFlags($languages, $defaultLanguage, $divLangName, 'ccontent');
				echo '</div>
				<div class="clear space">&nbsp;</div>';
				
				echo '</fieldset><div class="clear space">&nbsp;</div>';
				
			/*** SEO ***/
			echo '<fieldset>
			
				<legend>'.$this->l('SEO').'</legend>';
				
				// URL REWRITE
				echo '<label>'.$this->l('Friendly URL').' </label>
						<div class="margin-form">';
							foreach ($languages as $language)
								echo '<div id="clink_rewrite_'.$language['id_lang'].'" style="display: '.($language['id_lang'] == $defaultLanguage ? 'block' : 'none').'; float: left;">
									<input size="33" id="input_link_rewrite_'.$language['id_lang'].'" type="text" name="link_rewrite_'.$language['id_lang'].'" value="'.htmlentities($this->getFieldValue($obj, 'link_rewrite', intval($language['id_lang'])), ENT_COMPAT, 'UTF-8').'" />
								</div>';
						$this->displayFlags($languages, $defaultLanguage, $divLangName, 'clink_rewrite');
				echo '</div>
					<div class="clear space">&nbsp;</div>';
				
				// DESC
				echo '<label>'.$this->l('META description').'</label>
						<div class="margin-form">';
					foreach ($languages as $language)
						echo '<div id="meta_description_'.$language['id_lang'].'" style="display: '.($language['id_lang'] == $defaultLanguage ? 'block' : 'none').';float: left;">
								<textarea class="mceNoEditor" cols="80" rows="3" name="meta_description_'.$language['id_lang'].'">'.htmlentities(stripslashes($this->getFieldValue($obj, 'meta_description', $language['id_lang'])), ENT_COMPAT, 'UTF-8').'</textarea>
							</div>';
				$this->displayFlags($languages, $defaultLanguage, $divLangName, 'meta_description');
				echo '</div>
						<div class="clear space">&nbsp;</div>';
				
				// KEYWORDS
				echo '<label>'.$this->l('META keywords').' </label>
					<div class="margin-form">';
				
			foreach ($languages as $language)
					echo '<div id="meta_keywords_'.$language['id_lang'].'" style="display: '.($language['id_lang'] == $defaultLanguage ? 'block' : 'none').'; float: left;">
							<input size="40" type="text" name="meta_keywords_'.$language['id_lang'].'" value="'.htmlentities($this->getFieldValue($obj,'meta_keywords', intval($language['id_lang'])), ENT_COMPAT, 'UTF-8').'" />
						</div>';
				$this->displayFlags($languages, $defaultLanguage, $divLangName,'meta_keywords');
				
				echo '</div><div class="clear space">&nbsp;</div>';
				
			echo '</fieldset><div class="clear space">&nbsp;</div>';
			
			/*** OPTIONS ***/
			echo '<fieldset>
					<legend>'.$this->l('Options').'</legend>';
			
				echo '<label>'.$this->l('Position').' </label>
							<div class="margin-form">
								<select name="position">';
									echo '<option value="">'.$this->l('Alphabetical').'</option>';
								for($i=1; $i<= $nbCategories; $i++){
									echo '<option value="'.$i.'" '.($obj->position == $i ? "selected=selected" : "").'>'.$i.'</option>';
								}
							echo '</select>
							</div>
							<div class="clear">&nbsp;</div>';
					
					$active = $this->getFieldValue($obj, 'active');
					
					echo '<label>'.$this->l('Displayed').' </label>
						<div class="margin-form">
							<input type="radio" name="active" id="active_on" value="1" '.($active ? 'checked="checked" ' : '').'/>
							<label class="t" for="active_on"><img src="../img/admin/enabled.gif" alt="'.$this->l('Enabled').'" title="'.$this->l('Enabled').'" /></label>
							<input type="radio" name="active" id="active_off" value="0" '.(!$active ? 'checked="checked" ' : '').'/>
							<label class="t" for="active_off"><img src="../img/admin/disabled.gif" alt="'.$this->l('Disabled').'" title="'.$this->l('Disabled').'" /></label>
						</div>
						<div class="clear space">&nbsp;</div>';
				
				echo '</fieldset>';
					
				echo '<div class="margin-form space">
						<input type="submit" value="'.$this->l('   Save   ').'" name="submitAdd'.$this->table.'" class="button" />
					</div>
					
				<div class="small"><sup>*</sup> '.$this->l('Required field').'</div>
			</fieldset>
		</form>';
		
		require_once(_PS_MODULE_DIR_.$currentDir.'/tinymce.php');
	}
	
	protected function l($string, $class = __CLASS__, $addslashes = FALSE, $htmlentities = TRUE)
	{					
		global $_MODULES, $_MODULE, $_LANGADM, $cookie;
		
		$id_lang = (!isset($cookie) OR !is_object($cookie)) ? intval(Configuration::get('PS_LANG_DEFAULT')) : intval($cookie->id_lang);
		$file = _PS_MODULE_DIR_.'prestapress/'.Language::getIsoById($id_lang).'.php';
		if (file_exists($file) AND include_once($file))
			$_MODULES = !empty($_MODULES) ? array_merge($_MODULES, $_MODULE) : $_MODULE;
		if (!is_array($_MODULES))
			return (str_replace('"', '&quot;', $string));
		$source = Tools::strtolower(get_class($this));
		$string2 = str_replace('\'', '\\\'', $string);
		
		$currentKey = '<{prestapress}'._THEME_NAME_.'>adminprestapresscategory_'.md5($string2);
		$defaultKey = '<{prestapress}prestashop>adminprestapresscategory_'.md5($string2);
		
		$_MODULES = array_change_key_case($_MODULES,CASE_LOWER);
		
		if (key_exists($currentKey, $_MODULES)){
			$str = $_MODULES[$currentKey];	
		}elseif (key_exists($defaultKey, $_MODULES))
			$str = $_MODULES[$defaultKey];
		elseif (key_exists('AdminTab'.md5($string2), $_LANGADM))
			$str = $_LANGADM['AdminTab'.md5($string2)];
		else{
			return parent::l($string);
		}
		
		$str = $htmlentities ? htmlentities($str, ENT_QUOTES, 'utf-8') : $str;
		return str_replace('"', '&quot;', ($addslashes ? addslashes($str) : stripslashes($str)));
	}

}


?>
