<?php

include('../../config/config.inc.php');

include(_PS_ROOT_DIR_.'/init.php');

require_once(_PS_MODULE_DIR_."prestapress/prestapress.php");
require_once(_PS_MODULE_DIR_."prestapress/classes/PspressPublication.php");
require_once(_PS_MODULE_DIR_."prestapress/classes/PspressCategory.php");

$pressConf = Prestapress::getPreferences();

$css_files[_MODULE_DIR_.'prestapress/prestapress.css'] = 'screen';

$psversion = floatval(_PS_VERSION_) < 1.4 ? 13 : 14;
$smarty->assign('psversion',$psversion);

$listLink = PspressPublication::listLink();
$smarty->assign('listLink',$listLink);


/*** URL MANAGEMENT ***/
$id_publication = null;
$id_category = null;
$id_lang = (int) $cookie->id_lang;

if($pressConf['rewrite_active']){
	//GET IDs BY URL
	$pattern_category = '/articles\/[0-9]+\-[a-zA-Z]*/';
	$pattern_post = '/article\/[0-9]+\-[a-zA-Z]*/';
	$dir = substr(strrchr($_SERVER['REQUEST_URI'], "/"), 1);
	
	if(preg_match($pattern_category, $_SERVER['REQUEST_URI'], $matches)){
		//category
		$info = explode('-',$dir);
		if(isset($info[0]) != '' && is_numeric($info[0]))
			$id_category = $info[0];
	}elseif(preg_match($pattern_post, $_SERVER['REQUEST_URI'], $matches)){
		//post
		$info = explode('-',$dir);
		if(isset($info[0]) != '' && is_numeric($info[0]))
			$id_publication = $info[0];	
	}
	
}else{
	if(isset($_GET['id']) && is_numeric($_GET['id'])){
		$id_publication = $_GET['id'];
	}elseif(isset($_GET['category']) && is_numeric($_GET['category'])){
		$id_category = $_GET['category'];
	}
}

$publication = null;
if($id_publication && is_numeric($id_publication)){ 
	$publication = new PspressPublication($id_publication,$id_lang);
}

if(!is_null($publication) && $publication->status == 'published'){ 
	
	if($pressConf['view_display_popin'] == 1){
		if(file_exists(_PS_ROOT_DIR_.'/js/jquery/jquery.fancybox-1.3.4.js')){
			$css_files[_PS_CSS_DIR_.'jquery.fancybox-1.3.4.css'] = 'screen';
			$js_files[] = _PS_JS_DIR_.'jquery/jquery.fancybox-1.3.4.js';		
			$smarty->assign('fancybox',true);
		}elseif(file_exists(_PS_ROOT_DIR_.'/js/jquery/thickbox-modified.js')){
			$css_files[__PS_BASE_URI__.'css/thickbox.css'] = 'screen';
			$js_files[] = __PS_BASE_URI__.'js/jquery/thickbox-modified.js';
			$thickbox = true;
		}
	}	
	
	/*** view article ***/
	$images = $publication->getAllImages(false,true);
	$categories = $publication->listCategories($id_lang,true,true);	
	$products = $publication->getProducts($id_lang);
	$related = $publication->listRelated($id_lang,true,true);
	
	if(is_array($related) && count($related) > 0){
		$i = 0;
		foreach($related as $val){
			$related[$i]['link'] = PspressPublication::getArticleLink($val['id_press_publication'],$val['link_rewrite']);
		}
	}
	
	$img_path = $pressConf['img_save_path'].$publication->id.'/';
	$img_width = $pressConf['img_width'];
		
	if($pressConf['display_img'] == 'list'){
		if(count($images) > 1){
			foreach($images as $val){
				$file_path = _PS_ROOT_DIR_.'/'.$img_path.$val['id_press_image'].'.'.$val['type'];
				if(!is_file($file_path)) continue;
				$size = getimagesize($file_path);
				if($size[0] < $img_width){
					$img_width = $size[0];
				}
			}
		}
	}
	
	/* Metas */
	if(method_exists($smarty,'get_template_vars')){
		$curr_meta_title = $smarty->get_template_vars('meta_title');
	}elseif(method_exists($smarty,'getTemplateVars')){
		$curr_meta_title = $smarty->getTemplateVars('meta_title');	
	}
	
	$meta_description = $publication->meta_description != '' ? $publication->meta_description : $publication->excerpt;

	$smarty->assign(array('meta_title' => $curr_meta_title.' - '.$publication->title,
							  'meta_description' => $meta_description,
							  'meta_keywords' => $publication->meta_keywords));	
	
	include(_PS_ROOT_DIR_.'/header.php');
	
	if($pressConf['view_display_popin'] == 1 && isset($thickbox) && $thickbox == true){
		$smarty->display(_PS_THEME_DIR_.'thickbox.tpl');
	}
	
	if(is_array($categories) && count($categories) > 0){
		$i = 0;
		foreach($categories as $cat){
			$categories[$i]['link'] = PspressCategory::getCategoryLink($cat['id_press_category'],$cat['link_rewrite']);
			$i++;
		}
	}
	
	$smarty->assign(array(
		'publication' => $publication,
		'images' => $images,
		'press_conf' => $pressConf,
		'img_path' => _PS_BASE_URL_.__PS_BASE_URI__.$img_path,
		'img_width' => $img_width,
		'products' => $products,
		'related'  => $related,
		'press_categories' => $categories
	));

	$smarty->display(_PS_MODULE_DIR_.'prestapress/prestapress-view.tpl');
	
}else{
	
	/*** LIST articles ***/
	
	$limit_per_page = intval($pressConf['list_limit_page']);
	$current_page = isset($_GET['p']) && is_numeric($_GET['p']) ? intval($_GET['p']) : 1;
	$start = ($current_page-1) * $limit_per_page;
	
	$category = null;
	if($id_category && is_numeric($id_category)){
		$category = new PspressCategory($id_category,$id_lang);
	}
	
	if(!is_null($category) && $category->active){ // is category list
		
		//CATEGORY ARTICLES
		
		$nb_articles = $category->nbPublications($id_lang,true,true);
		$list = $category->getPublications($id_lang,true,$start,intval($pressConf['list_limit_page']),true);
		
		/* Metas */
		if(method_exists($smarty,'get_template_vars')){
			$curr_meta_title = $smarty->get_template_vars('meta_title');
		}elseif(method_exists($smarty,'getTemplateVars')){
			$curr_meta_title = $smarty->getTemplateVars('meta_title');
		}
		
		$smarty->assign(array('meta_title' => $curr_meta_title.' - '.$category->name, 
							  'meta_description' => $category->meta_description,
							  'meta_keywords' => $category->meta_keywords));
		
		$categoryLink  = PspressCategory::getCategoryLink($category->id,$category->link_rewrite);
			
		$smarty->assign('category',$category);
		$smarty->assign('categoryLink',$categoryLink);
		$smarty->assign('paginationLink', $categoryLink.($pressConf['rewrite_active'] ? '?p=' : '&p='));
		
	}else{ 
		
		if(isset($_GET['press_query']) && $_GET['press_query'] != ''){
			//search articles
			$press_query = $_GET['press_query'];
			
			$nb_articles = PspressPublication::findPrestapress($press_query, $id_lang, true, true);
			$list = PspressPublication::findPrestapress($press_query, $id_lang, true, false, $start, $limit_per_page);
			
			$smarty->assign('press_query',$press_query);
			$smarty->assign('paginationLink',$listLink.'?press_query='.$press_query.'&p=');
		}else{
			//all articles
			$nb_articles = PspressPublication::nbPrestapress($id_lang,true,null,null,null,true);
			$list = PspressPublication::listPrestapress($id_lang,true,$start,$limit_per_page,null,null,null,true);
			
			$smarty->assign('paginationLink',$listLink.'?p=');
		}
	}
	
	/** pagination **/
	$nb_pages = ceil($nb_articles / $limit_per_page);
	$next = $current_page > 1  ? true : false; //articles plus rcents
	$back = $current_page >= 1 && ($current_page < $nb_pages) ? true : false; //articles prcdents
	
	include(_PS_ROOT_DIR_.'/header.php');
	
	if(is_array($list) && count($list) > 0){
		$i = 0;
		foreach($list as $val){
			$list[$i]['link'] = PspressPublication::getArticleLink($val['id_press_publication'],$val['link_rewrite']);
			
			$categories = PspressCategory::getPublicationCategories($id_lang,$val['id_press_publication'],true);
			if($categories){
				$j = 0;
				foreach($categories as $cat){
					$categories[$j]['link'] = PspressCategory::getCategoryLink($cat['id_press_category'],$cat['link_rewrite']);
					$j++;
				}
			}
			$list[$i]['categories'] = $categories;
			
			$i++;
		}
	}

	$smarty->assign(array(
		'press_list' => $list,
		'press_conf' => $pressConf,
		'img_path' => _PS_BASE_URL_.__PS_BASE_URI__.$pressConf['img_save_path'],
		'next' => $next,
		'back' => $back,
		'curr_page' => $current_page
	));
	
	$smarty->display(_PS_MODULE_DIR_.'prestapress/prestapress-list.tpl');
}
 
include(_PS_ROOT_DIR_.'/footer.php');

?>