<?php 

class Prestapressblocksearch extends Module
{
	private $_html = '';
	private static $pref = null;
	public static $default_values = array("block_search_position" => "leftColumn");
	
	public function __construct()
	{
		$this->name = 'prestapressblocksearch';
 	 	$this->version = '1.9';
 	 	$this->module_key = "77f48b3e831430e3acdc2a1181d1a8d1";
 	 	
		if(floatval(_PS_VERSION_) >= 1.4){
 	 		$this->tab = 'front_office_features';
 	 	}else{
 	 		$this->tab = 'Prestapress';
 	 	}

		parent::__construct();
		
		if(Tools::getValue('tab') == 'AdminModules' && $this->active) $this->checkServerConf();
		
		$this->displayName = $this->l('Prestapress search block module');
		$this->description = $this->l('Adds a block to search in prestapress articles');
	}
	
	public function install()
	{
		if (parent::install() == false OR !$this->registerHook(self::$default_values['block_search_position'])) return false;
		if(!Configuration::updateValue('PRESTAPRESS_SEARCH_CONF',base64_encode(serialize(self::$default_values)))) return false;
		return true;		
	}
	
	public function hookLeftColumn($params){
		global $smarty, $cookie;	
		
		require_once(_PS_MODULE_DIR_."prestapress/prestapress.php");
		require_once(_PS_MODULE_DIR_."prestapress/classes/PspressPublication.php");
		
		if(isset($_GET['search_query']) && trim($_GET['search_query']) != ''){
			$search_query = $_GET['search_query'];
			$press_nb_results = PspressPublication::findPrestapress($search_query, intval($cookie->id_lang), true, true);
			
			$smarty->assign('press_search_term',$search_query);
			$smarty->assign('press_search_nb',$press_nb_results);
		}
		
		$smarty->assign('pressListLink',PspressPublication::listLink());

		return $this->display(__FILE__, 'blocksearch.tpl');
	}
	
	public function hookRightColumn($params){
		global $smarty, $cookie;	
		return $this->hookLeftColumn($params);
	}
	
	private function _postProcess()
	{
		if (Tools::isSubmit('submitBlockSearch'))
		{
			$pref = $_POST['pref'];
			$old_values = self::getPreferences();
			$new_values = array_merge(self::$default_values,$pref);
			Configuration::updateValue('PRESTAPRESS_SEARCH_CONF',base64_encode(serialize($new_values)));
			
			if($new_values['block_search_position'] != $old_values['block_search_position']){
				$old_hook_id = Hook::get($old_values['block_search_position']);
				$this->unregisterHook($old_hook_id);
				$this->registerHook($new_values['block_search_position']);
			}
		}
		$this->_html .= '<div class="conf confirm"><img src="../img/admin/ok.gif" alt="'.$this->l('ok').'" /> '.$this->l('Settings updated').'</div>';
	}
	
	public function getContent()
	{
		if($this->warning != ''){
			$this->_html .= '<div style="width:680px;" class="warning bold">'.$this->warning.'</div>';
			return $this->_html;
		}
		$this->_html .= '<h2>'.$this->displayName.'</h2>';
		if(isset($_POST) && !empty($_POST)){ $this->_postProcess(); }
		$this->_displayForm();
		return $this->_html;
	}
	
	private function _displayForm()
	{
		$values = !empty($_POST) ? Tools::getValue('pref') : array_merge(self::$default_values,self::getPreferences());
		$this->_html .= '<form action="'.$_SERVER['REQUEST_URI'].'" method="post">
				<fieldset>
				<legend>'.$this->l('Prestapress search block settings').'</legend>
				
				<label>'.$this->l('Block search position').'</label> 
				<div class="margin-form">
					<select name="pref[block_search_position]">
						<option value="leftColumn" '.($values['block_search_position'] == "leftColumn" ? "selected" : "").'>'.$this->l('Left').' &nbsp;</option>
						<option value="rightColumn" '.($values['block_search_position'] == "rightColumn" ? "selected" : "").'>'.$this->l('Right').' &nbsp;</option>
					</select>
				</div>
				<div class="clear"></div><br />
				
				</fieldset>
				<br />
				<div class="clear"></div>
				<input type="submit" name="submitBlockSearch" value="'.$this->l('Save').'" class="button" />
			</form>';
	}
	
	public static function getPreferences(){
		if(is_null(self::$pref)){
			$config = Configuration::get('PRESTAPRESS_SEARCH_CONF');
			$options = self::$default_values;
			if($config) $options = array_merge($options,unserialize(base64_decode($config)));
			self::$pref = $options;
		}
		return self::$pref;
	}
	
	public function checkServerConf()
	{
		if(!self::isInstalled('prestapress')){
			$this->warning = $this->l('This module needs Prestapress core module available to work');
			return false;
		}
		return true;
	}
	
}