<?php

class Prestapresscategories extends Module
{	
	private $_html = '';
	private static $pref = null;
	public static $default_values = array("block_categories_position" => "leftColumn");
	
	public function __construct()
	{
		$this->name = 'prestapresscategories';
 	 	$this->version = '1.9';
 	 	$this->module_key = "77f48b3e831430e3acdc2a1181d1a8d1";
 	 	
		if(floatval(_PS_VERSION_) >= 1.4){
 	 		$this->tab = 'front_office_features';
 	 	}else{
 	 		$this->tab = 'Prestapress';
 	 	}

		parent::__construct();
		
		if(Tools::getValue('tab') == 'AdminModules' && $this->active) $this->checkServerConf();
		
		$this->displayName = $this->l('Prestapress categories block module');
		$this->description = $this->l('Adds a block to display prestapress categories');
	}
	
	public function install()
	{
		if (parent::install() == false OR $this->registerHook(self::$default_values['block_categories_position']) == false) return false;
		if(!Configuration::updateValue('PRESTAPRESS_CATEGORIES_CONF',base64_encode(serialize(self::$default_values)))) return false;
		return true;		
	}
	
	public function hookLeftColumn($params){
		global $smarty, $cookie;	
		
		if(!$this->checkServerConf()) return false;

		require_once(_PS_MODULE_DIR_."prestapress/prestapress.php");
		require_once(_PS_MODULE_DIR_."prestapress/classes/PspressCategory.php");
		
		$pref = array_merge(Prestapress::getPreferences(),self::getPreferences());
		
		$list = PspressCategory::listCategories(intval($cookie->id_lang),true,true);
		
		if(is_array($list) && count($list) > 0){
			$i = 0;
			foreach($list as $val){
				$list[$i]['link'] = PspressCategory::getCategoryLink($val['id_press_category'],$val['link_rewrite']);
				$i++;
			}
		}
		
		$smarty->assign(array('press_categories_conf' => $pref,'press_categories_list' => $list));
		
		return $this->display(__FILE__, 'blockcategories.tpl');
		
	}
	
	public function hookRightColumn($params){
		return $this->hookLeftColumn($params);
	}	
	
	private function _postProcess()
	{
		if (Tools::isSubmit('submitBlockCategories'))
		{
			$pref = $_POST['pref'];
			$old_values = self::getPreferences();
			$new_values = array_merge(self::$default_values,$pref);
			Configuration::updateValue('PRESTAPRESS_CATEGORIES_CONF',base64_encode(serialize($new_values)));
			
			if($new_values['block_categories_position'] != $old_values['block_categories_position']){
				$old_hook_id = Hook::get($old_values['block_categories_position']);
				$this->unregisterHook($old_hook_id);
				$this->registerHook($new_values['block_categories_position']);
			}
		}
		$this->_html .= '<div class="conf confirm"><img src="../img/admin/ok.gif" alt="'.$this->l('ok').'" /> '.$this->l('Settings updated').'</div>';
	}
	
	public function getContent()
	{
		if($this->warning != ''){
			$this->_html .= '<div style="width:680px;" class="warning bold">'.$this->warning.'</div>';
			return $this->_html;
		}
		
		$this->_html .= '<h2>'.$this->displayName.'</h2>';
		$this->_html .= '<p>'.$this->l('If you want to add categories, you must go to the prestapress sub tab on the navigation menu').'</p>';
		
		if(isset($_POST) && !empty($_POST)){ $this->_postProcess(); }
		
		$this->_displayForm();
		
		return $this->_html;
	}
	
	private function _displayForm()
	{
		$values = !empty($_POST) ? Tools::getValue('pref') : array_merge(self::$default_values,self::getPreferences());
		$this->_html .= '<form action="'.$_SERVER['REQUEST_URI'].'" method="post">
				<fieldset>
				<legend>'.$this->l('Categories block settings').'</legend>
				
				<label>'.$this->l('Block categories position').'</label> 
				<div class="margin-form">
					<select name="pref[block_categories_position]">
						<option value="leftColumn" '.($values['block_categories_position'] == "leftColumn" ? "selected" : "").'>'.$this->l('Left').' &nbsp;</option>
						<option value="rightColumn" '.($values['block_categories_position'] == "rightColumn" ? "selected" : "").'>'.$this->l('Right').' &nbsp;</option>
					</select>
				</div>
				<div class="clear"></div><br />
				
				</fieldset>
				<br />
				<div class="clear"></div>
				<input type="submit" name="submitBlockCategories" value="'.$this->l('Save').'" class="button" />
			</form>';
	}
	
	public static function getPreferences(){
		if(is_null(self::$pref)){
			$config = Configuration::get('PRESTAPRESS_CATEGORIES_CONF');
			$options = self::$default_values;
			if($config) $options = array_merge($options,unserialize(base64_decode($config)));
			self::$pref = $options;
		}
		return self::$pref;
	}
	
	public function checkServerConf()
	{
		if(!self::isInstalled('prestapress')){
			$this->warning = $this->l('This module needs Prestapress core module available to work');
			return false;
		}
		return true;
	}
	
}