<?php

class Prestapresslastblock extends Module
{	
	private $_html = '';
	private static $pref = null;
	public static $default_values = array("img_block_width" => 50,
										"block_limit_items" => 5,
										"block_display_date" => 1,
										"block_display_img" => 1,	
										"block_articles_position" => "leftColumn", 								
										"block_articles_home" => 0);
	public function __construct()
	{
		$this->name = 'prestapresslastblock';
 	 	$this->version = '1.9';
 	 	$this->module_key = "77f48b3e831430e3acdc2a1181d1a8d1";
 	 	
 	 	if(floatval(_PS_VERSION_) >= 1.4){
 	 		$this->tab = 'front_office_features';
 	 	}else{
 	 		$this->tab = 'Prestapress';
 	 	}
 	 	
		parent::__construct();
			
		if(Tools::getValue('tab') == 'AdminModules' && $this->active) $this->checkServerConf();
		
		$this->displayName = $this->l('Prestapress last articles block');
		$this->description = $this->l('Adds a block to display last articles');
	}
	
	public function install()
	{
		if (parent::install() == false OR $this->registerHook(self::$default_values['block_articles_position']) == false) return false;
		if(!Configuration::updateValue('PRESTAPRESS_BLOCK_CONF',base64_encode(serialize(self::$default_values)))) return false;
		return true;	
	}
	
	public function hookLeftColumn($params){
		global $smarty, $cookie;	
		
		if(!$this->checkServerConf()) return false;
		
		$is_home = (basename($_SERVER['PHP_SELF']) == 'index.php') ? true : false;
		require_once(_PS_MODULE_DIR_."prestapress/prestapress.php");
		require_once(_PS_MODULE_DIR_."prestapress/classes/PspressPublication.php");

		$pref = array_merge(Prestapress::getPreferences(),self::getPreferences());
		
		if(!($is_home && $pref['block_articles_home'] == 1)){
				
			$prestapress = new PspressPublication();
			$list = $prestapress->listPrestapress(intval($cookie->id_lang),true,0,intval($pref['block_limit_items']),null,null,null,true);
			
			if(is_array($list) && count($list) > 0){
				$i = 0;
				foreach($list as $val){
					$list[$i]['link'] = PspressPublication::getArticleLink($val['id_press_publication'],$val['link_rewrite']);
					$i++;
				}
			}
			
			$listLink = PspressPublication::listLink();
	
			$smarty->assign(array('press_block_list' => $list,'press_conf' => $pref,'listLink' => $listLink));
			return $this->display(__FILE__, 'prestapressblock.tpl');
		}
	}
	
	public function hookRightColumn($params){
		return $this->hookLeftColumn($params);
	}
	
	public function hookHome($params){
		global $smarty, $cookie, $css_files;	
		
		if(!$this->checkServerConf()) return false;
		
		require_once(_PS_MODULE_DIR_."prestapress/prestapress.php");
		require_once(_PS_MODULE_DIR_."prestapress/classes/PspressPublication.php");	
		
		$pref = array_merge(Prestapress::getPreferences(),self::getPreferences());
		$list = PspressPublication::listPrestapress(intval($cookie->id_lang),true,0,intval($pref['block_limit_items']),null, null, null, true);
		
		if(is_array($list) && count($list) > 0){
			$i = 0;
			foreach($list as $val){
				$list[$i]['link'] = PspressPublication::getArticleLink($val['id_press_publication'],$val['link_rewrite']);
				$i++;
			}
		}
		
		$listLink = PspressPublication::listLink();
	
		$smarty->assign(array('press_block_list' => $list,'press_conf' => $pref,'listLink' => $listLink));
		return $this->display(__FILE__, 'prestapresshome.tpl');
	}
	
	
	public function getContent()
	{
		if($this->warning != ''){
			$this->_html .= '<div style="width:680px;" class="warning bold">'.$this->warning.'</div>';
			return $this->_html;
		}
		
		$this->_html .= '<h2>'.$this->displayName.'</h2>';
		$this->_html .= '<p>'.$this->l('If you want to add articles, you must go to the prestapress sub tab on the navigation menu').'</p>';
		if (isset($_POST) && !empty($_POST)){
			$this->_postValidation();
			if (!isset($this->_postErrors) || !sizeof($this->_postErrors)){
				$this->_postProcess();
			}else{
				foreach ($this->_postErrors AS $err) $this->_html .= '<div class="alert error">'. $err .'</div>';
			}
		}else{
			$this->_html .= '<br />';
		}
		
		$this->_displayForm();
		return $this->_html;
	}

	private function _displayForm()
	{
		$values = !empty($_POST) ? Tools::getValue('pref') : array_merge(self::$default_values,self::getPreferences());
	
		$this->_html .= '<form action="'.$_SERVER['REQUEST_URI'].'" method="post">
				<fieldset>
				<legend>'.$this->l('Block last articles settings').'</legend>
				
				<label>'.$this->l('Number of articles to display in blocks').'</label> 
				<div class="margin-form">
				<input type="text" name="pref[block_limit_items]" value="'.$values['block_limit_items'].'" size="3" />
				</div>
				<div class="clear"></div><br />
				
				<label>'.$this->l('Display date').'</label>  
				<div class="margin-form">
				<input type="checkbox" name="pref[block_display_date]" value="1" '.((isset($values['block_display_date']) && $values['block_display_date'] == '1') ? 'checked' : '').'/>
				</div>
				<div class="clear"></div><br />
				
				<label>'.$this->l('Block last articles position').'</label> 
				<div class="margin-form">
					<select name="pref[block_articles_position]">
						<option value="leftColumn" '.($values['block_articles_position'] == "leftColumn" ? "selected" : "").'>'.$this->l('Left').' &nbsp;</option>
						<option value="rightColumn" '.($values['block_articles_position'] == "rightColumn" ? "selected" : "").'>'.$this->l('Right').' &nbsp;</option>
					</select>
				</div>
				<div class="clear"></div><br />
				
				<label>'.$this->l('In homepage, display block in middle content').'</label>  
				<div class="margin-form">
				<input type="checkbox" name="pref[block_articles_home]" value="1" '.((isset($values['block_articles_home']) && $values['block_articles_home'] == '1') ? 'checked' : '').'/>&nbsp; '.$this->l('instead of column').'
				</div>
				
				<div class="clear"></div><br />
				
				<label>'.$this->l('Display images').'</label>  
				<div class="margin-form">
				<input type="checkbox" name="pref[block_display_img]" value="1" '.((isset($values['block_display_img']) && $values['block_display_img'] == '1') ? 'checked' : '').'/>
				</div>
				<div class="clear"></div><br />
				
				<label>'.$this->l('Image width').'</label>
				<div class="margin-form">
					<input type="text" name="pref[img_block_width]" value="'.$values['img_block_width'].'" size="3" /> px
				</div><div class="clear"></div><br />
				
				</fieldset>
				<br />
				<div class="clear"></div>
				<input type="submit" name="submitBlockPrestapress" value="'.$this->l('Save').'" class="button" />
			</form>';
	}
	
	private function _postValidation(){
		if (isset($_POST['submitBlockPrestapress']))
		{
			if (empty($_POST['pref']['img_block_width']) || !is_numeric($_POST['pref']['img_block_width']))
				$this->_postErrors[] = $this->l('Numeric width is required for image size.');
			
			if (empty($_POST['pref']['block_limit_items']) || !is_numeric($_POST['pref']['block_limit_items']))
				$this->_postErrors[] = $this->l('Number of articles in block must be a number.');
		}
	}
	
	private function _postProcess()
	{
		if (Tools::isSubmit('submitBlockPrestapress'))
		{
			$pref = $_POST['pref'];
			$old_values = self::getPreferences();
			
			$checkboxes = array('block_display_date','block_articles_home','block_display_img');	
			foreach($checkboxes as $input){ if(!isset($pref[$input])) $pref[$input] = 0; }
			
			$new_values = array_merge(self::$default_values,$pref);
			Configuration::updateValue('PRESTAPRESS_BLOCK_CONF',base64_encode(serialize($new_values)));
			
			if($new_values['block_articles_position'] != $old_values['block_articles_position']){
				$old_hook_id = Hook::get($old_values['block_articles_position']);
				$this->unregisterHook($old_hook_id);
				$this->registerHook($new_values['block_articles_position']);
			}
		
			if($new_values['block_articles_home'] != $old_values['block_articles_home']){
				
				if($new_values['block_articles_home'] == 1){
					$this->registerHook('home');
				}else{
					$old_hook_id = Hook::get('home');
					$this->unregisterHook($old_hook_id);
				}
			}
	
		}
		$this->_html .= '<div class="conf confirm"><img src="../img/admin/ok.gif" alt="'.$this->l('ok').'" /> '.$this->l('Settings updated').'</div>';
	}
	
	public static function getPreferences(){
		if(is_null(self::$pref)){
			$config = Configuration::get('PRESTAPRESS_BLOCK_CONF');
			$options = self::$default_values;
			if($config) $options = array_merge($options,unserialize(base64_decode($config)));
			self::$pref = $options;
		}
		return self::$pref;
	}
	
	public function checkServerConf()
	{
		if(!self::isInstalled('prestapress')){
			$this->warning = $this->l('This module needs Prestapress core module available to work');
			return false;
		}
		return true;
	}
	
}